/*  Festalon - NSF Player
 *  Copyright (C) 2002 Ben Parnell
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "common.h"

uint8 dopol;
static uint8 MapperExRAM[0x80];

static void DoNamcoSound(int32 *Wave, int Count);

DECLFR(Namco_Read4800)
{
	uint8 ret=MapperExRAM[dopol&0x7f];
	if(dopol&0x80)
	 dopol=(dopol&0x80)|((dopol+1)&0x7f);
	return ret;
}

static DECLFW(Mapper19_write)
{
	A&=0xF800;
        switch(A)
	{
	 case 0x4800:
		   if(dopol&0x40)
                   {
		    GameExpSound.NeoFill=DoNamcoSound;
                   }
		   MapperExRAM[dopol&0x7f]=V;
                   if(dopol&0x80)
                    dopol=(dopol&0x80)|((dopol+1)&0x7f);
                   break;
        case 0xf800: dopol=V;break;
        }
}

static void DoNamcoSound(int32 *Wave, int Count);

static uint64 vcount[8];

static void DoNamcoSound(int32 *Wave, int Count)
{
	int P,V;

      for(P=7;P>=7-((MapperExRAM[0x7F]>>4)&7);P--)
      {
       if(!(FSettings.disabled&(0x20<<P)))
       if((MapperExRAM[0x44+(P<<3)]&0xE0) && (MapperExRAM[0x47+(P<<3)]&0xF))
       {
	uint32 freq;
        int32 vco;
	uint32 lengo,envelope;
        int32 inc;

        vco=vcount[P];
        freq=MapperExRAM[0x40+(P<<3)];
        freq|=MapperExRAM[0x42+(P<<3)]<<8;
        freq|=(MapperExRAM[0x44+(P<<3)]&3)<<16;

        if(!freq) continue;

	{
	 int c=((MapperExRAM[0x7F]>>4)&7)+1;
	 //inc=(((int64)freq*21477272/(c*45)))/FSettings.SndRate;
	 inc=(long double)((long double)freq*
                21477272/((long double)0x400000*c*45))/((long double)FSettings.SndRate)*(long double)(65536);
	}

        envelope=((MapperExRAM[0x47+(P<<3)]&0xF)<<18)/15;
        lengo=((8-((MapperExRAM[0x44+(P<<3)]>>2)&7)))<<2;

        for(V=0;V<Count*16;V++)
        {
	 uint32 index,index2;
         int32 m1;

	 index=(vco>>16)%lengo;
	 index2=(((vco+inc)>>16))%lengo;

	 m1=MapperExRAM[(((MapperExRAM[0x46+(P<<3)]+index)&0xFF)>>1)];
	 if((MapperExRAM[0x46+(P<<3)]+index)&1)
	  m1>>=4;
	 m1&=0xF;

         m1-=8;
         m1*=envelope;
         m1>>=6+4+4;

         Wave[V>>4]+=m1; //moo;
	 vco+=inc;
	}
        vcount[P]=vco;
       }
      }
}

static void M19SC(void)
{
 Mapper19_ESI();
}

void Mapper19_ESI(void)
{
  GameExpSound.RChange=M19SC;
  SetWriteHandler(0xf800,0xffff,Mapper19_write);
  SetWriteHandler(0x4800,0x4fff,Mapper19_write);
  SetReadHandler(0x4800,0x4fff,Namco_Read4800);
}
